# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::LuisAuthoring::V3_0_preview
  module Models
    #
    # A prediction and label pair of an example.
    #
    class LabeledUtterance

      include MsRestAzure

      # @return [Integer] ID of Labeled Utterance.
      attr_accessor :id

      # @return [String] The utterance. For example, "What's the weather like
      # in seattle?"
      attr_accessor :text

      # @return [Array<String>] The utterance tokenized.
      attr_accessor :tokenized_text

      # @return [String] The intent matching the example.
      attr_accessor :intent_label

      # @return [Array<EntityLabel>] The entities matching the example.
      attr_accessor :entity_labels

      # @return [Array<IntentPrediction>] List of suggested intents.
      attr_accessor :intent_predictions

      # @return [Array<EntityPrediction>] List of suggested entities.
      attr_accessor :entity_predictions


      #
      # Mapper for LabeledUtterance class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LabeledUtterance',
          type: {
            name: 'Composite',
            class_name: 'LabeledUtterance',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'Number'
                }
              },
              text: {
                client_side_validation: true,
                required: false,
                serialized_name: 'text',
                type: {
                  name: 'String'
                }
              },
              tokenized_text: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tokenizedText',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              intent_label: {
                client_side_validation: true,
                required: false,
                serialized_name: 'intentLabel',
                type: {
                  name: 'String'
                }
              },
              entity_labels: {
                client_side_validation: true,
                required: false,
                serialized_name: 'entityLabels',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EntityLabelElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EntityLabel'
                      }
                  }
                }
              },
              intent_predictions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'intentPredictions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'IntentPredictionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'IntentPrediction'
                      }
                  }
                }
              },
              entity_predictions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'entityPredictions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EntityPredictionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EntityPrediction'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
